architectury { platformSetupLoomIde(); forge() }
repositories {
    maven(url = "https://maven.neoforged.net/releases/")
    maven(url = "https://thedarkcolour.github.io/KotlinForForge/")
}


dependencies {
    neoForge("net.neoforged:neoforge:${rootProject.property("forge_version").toString().let {
        return@let if (it.length > 4) it else "$it.+"
    }}")
    implementation("thedarkcolour:kotlinforforge:${rootProject.property("kotlinforforge")}")
    modApi("me.shedaniel.cloth:cloth-config-neoforge:${rootProject.property("clothconfig_version")}")
    implementation(project(path = ":common", configuration = "namedElements")) { isTransitive = false }
    add("developmentForge", project(path = ":common")) { isTransitive = false }
    shadowC(project(path = ":common", configuration = "transformProductionForge")) { isTransitive = false }
}; loom {
    runs {
        val args: MutableList<String> = mutableListOf("-Dfml.earlyprogresswindow=false")
        args += listOf("--illegal-access=permit")
        this.forEach {
            it.vmArgs(args)
        }
    }
}
